#   +------------------------------------------------------------------------+
#   | Licensed Materials - Property of IBM                                   |
#   | Copyright IBM Corp. 2007. All Rights Reserved.                         |
#   |                                                                        |
#   | US Government Users Restricted Rights - Use, duplication or disclosure |
#   | restricted by GSA ADP Schedule Contract with IBM Corp.                 |
#   +------------------------------------------------------------------------+

#The command line below invokes the log deltas operation with the input model files and the output 
# delta log file.
# The user needs to manually change the paths of the java.exe and startup.jar for his install 
# environment.

# Syntax: <jvm bin directory>java.exe -cp <eclipse home directory>\plugins
#\org.eclipse.equinox.launcher_???.jar" org.eclipse.equinox.launcher.Main -nosplash -data <workspace  #path> -application com.ibm.xtools.comparemerge.delta.annotation.ui.logdeltas -log=<delta log file #path> [-filetype=<local file name with extension>] <ancestor input file path> <local contributor input #file path>
# Where optional parameter is enclosed with [ ]
# File path or string data is enclosed with < >

# Input file path is absolute local file path, eclipse file resource path or ClearCase version file # path.
# Example: "c:\temp\modelfile1.emx", "/project1/folder 1/modelfile2.emx", "c:\workspace\folder 
#\modelfile3.emx@@\main\3"

# The optional file type is the full file name of the input file.
# It is used to determine the content type and merge manager.
# If your input files have no file extensions or wrong file extensions (such as temporary files),
# then you need to specify the file type parameter to enforce the content type of the input files.
# Example: -filetype="file1.emx"

# Command line for older version of Eclipse (before 3.3M5) which has the startup.jar
# "C:\Program Files\IBM\SDP70\jdk\bin\java.exe" -cp "C:\Program Files\IBM\SDP70\startup.jar" #org.eclipse.core.launcher.Main -nosplash -noupdate -data "C:\Program Files\IBM\SDP70\workspace" - #application com.ibm.xtools.comparemerge.delta.annotation.ui.logdeltas -log="C:\Program Files\IBM\SDP70
#\workspace\test1\deltalog.xml" "C:\Program Files\IBM\SDP70\workspace\test1\base.emx" "C:\Program Files
#\IBM\SDP70\workspace\test1\cont1.emx"

# For eclipse Eclipse 3.3M5 and later. Use the new command line below.
# Since the startup.jar is removed by eclipse, we substitute it with the org.eclipse.equinox.launcher #plugin
# Please search the org.eclipse.equinox.launcher_*.jar in your eclipse plugins directory and update the #-cp parameter below
# see details at http://wiki.eclipse.org/index.php/Equinox_Startup_Issues

#!/bin/bash

echo '/opt/IBM/SDP/jdk/bin/java -classpath "/opt/IBM/SDP/startup.jar" org.eclipse.core.launcher.Main -data "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer" -application com.ibm.xtools.comparemerge.delta.annotation.ui.logdeltas -log="/root/IBM/rationalsdp7.1/workspace/DeltalogViewer/deltalog.xml" "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer/UMLProj1/A.emx" "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer/UMLProj1/B.emx"'
/opt/IBM/SDP/jdk/bin/java -cp "/opt/IBM/SDP/startup.jar" org.eclipse.core.launcher.Main -data "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer" -application com.ibm.xtools.comparemerge.delta.annotation.ui.logdeltas -log="/A/deltalogABRelative.xml" "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer/UMLProj1/A.emx" "/root/IBM/rationalsdp7.1/workspace/DeltalogViewer/UMLProj1/B.emx"
