// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI'

#ifndef RTDConnexisAPI_H
#define RTDConnexisAPI_H

#ifdef PRAGMA
#pragma interface "RTDConnexisAPI.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDConnectionId.h>
#include <RTDMblk.h>
#include <RTDMessageStatus.h>
#include <RTDResult.h>
#include <RTDTransportId.h>
class RTDAuditHdr;
class RTDDataHdr;
class RTDTransportAddress;
class RTDTransportEndpoint;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
#include "RTObject_class.h"

typedef RTDResult (*RTDRegisterEndpointFcn) ( RTDTransportEndpoint * );
typedef RTDResult (*RTDDataMsgReceiveFcn) ( const RTDMessageStatus, const RTDDataHdr &, const char *, void **, const RTObject_class *);
typedef RTDResult (*RTDDataWithSenderMsgReceiveFcn) ( const RTDMessageStatus, const RTDDataHdr &, const char *, void **, const RTObject_class *, RTDTransportAddress *);
typedef RTDResult (*RTDAuditMsgReceiveFcn) ( const RTDMessageStatus, const RTDAuditHdr &, void **, const RTObject_class *, RTDTransportAddress * );
typedef RTDResult (*RTDDataWithSenderCidMsgReceiveFcn) ( const RTDMessageStatus, const RTDDataHdr &, const char *, void **, const RTObject_class *, RTDTransportAddress *, const RTDConnectionId & cid);
typedef RTDResult (*RTDAuditWithCidMsgReceiveFcn) ( const RTDMessageStatus, const RTDAuditHdr &, void **, const RTObject_class *, RTDTransportAddress *,  const RTDConnectionId & cid );

typedef RTDResult (*RTDEncodeFcn) (void *, const RTObject_class *, const unsigned char, unsigned char &, RTDMblk *&, const unsigned long, unsigned long &, unsigned long &, const unsigned long, const unsigned long );
typedef RTDMessageStatus (*RTDDecodeFcn) (const unsigned char, const unsigned char *, const unsigned long, const unsigned long, void**, const RTObject_class **);

typedef void (*RTDTransportNotifyFcn) (const RTDConnectionId &);
typedef void (*RTDNotifyIncompatibleFcn) (const RTDTransportAddress *);

// }}}USR
// }}}RME

class RTDConnexisAPI
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'transportId'
	RTDTransportId transportId;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'registerEndpoint'
	RTDRegisterEndpointFcn registerEndpoint;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'dataMsgReceive'
	RTDDataMsgReceiveFcn dataMsgReceive;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'dataWithSenderMsgReceive'
	RTDDataWithSenderMsgReceiveFcn dataWithSenderMsgReceive;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'dataWithSenderCidMsgReceive'
	RTDDataWithSenderCidMsgReceiveFcn dataWithSenderCidMsgReceive;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'auditMsgReceive'
	RTDAuditMsgReceiveFcn auditMsgReceive;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'auditWithCidMsgReceive'
	RTDAuditWithCidMsgReceiveFcn auditWithCidMsgReceive;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'encode'
	RTDEncodeFcn encode;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'decode'
	RTDDecodeFcn decode;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'transportFailure'
	RTDTransportNotifyFcn transportFailure;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'transportFailureRecovery'
	RTDTransportNotifyFcn transportFailureRecovery;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'transportRecovery'
	RTDTransportNotifyFcn transportRecovery;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' classAttribute 'notifyIncompatibleRequest'
	RTDNotifyIncompatibleFcn notifyIncompatibleRequest;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDConnexisAPI( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'GenerateDestructor'
	~RTDConnexisAPI( void );
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	inline RTDConnexisAPI & operator=( const RTDConnexisAPI & rtg_arg )
	{
		if( this != &rtg_arg )
		{
			transportId = rtg_arg.transportId;
			registerEndpoint = rtg_arg.registerEndpoint;
			dataMsgReceive = rtg_arg.dataMsgReceive;
			dataWithSenderMsgReceive = rtg_arg.dataWithSenderMsgReceive;
			dataWithSenderCidMsgReceive = rtg_arg.dataWithSenderCidMsgReceive;
			auditMsgReceive = rtg_arg.auditMsgReceive;
			auditWithCidMsgReceive = rtg_arg.auditWithCidMsgReceive;
			encode = rtg_arg.encode;
			decode = rtg_arg.decode;
			transportFailure = rtg_arg.transportFailure;
			transportFailureRecovery = rtg_arg.transportFailureRecovery;
			transportRecovery = rtg_arg.transportRecovery;
			notifyIncompatibleRequest = rtg_arg.notifyIncompatibleRequest;
		}
		return *this;
	}
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDConnexisAPI' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDConnexisAPI_H */

// }}}RME
