// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats'

#ifndef RTDMetricStats_H
#define RTDMetricStats_H

#ifdef PRAGMA
#pragma interface "RTDMetricStats.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDStats.h>
#include <RTDTransportId.h>
#include <RTDTransportStats.h>

// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
#include <stddef.h>

// }}}USR
// }}}RME

class RTDMetricStats : public RTDStats
{
public:
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDMetricStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'RTDMetricStats(int)'
	RTDMetricStats( int numberTransports );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'msgSent(const RTDTransportId,const unsigned char,const unsigned long,const unsigned long)'
	inline void msgSent( const RTDTransportId transport, const unsigned char dataFlag, const unsigned long size, const unsigned long dataSize )
	{
		// {{{USR operation 'msgSent(const RTDTransportId,const unsigned char,const unsigned long,const unsigned long)'
		if ( transport < maxTransports )
			transportStats[transport].msgSent(dataFlag, size, dataSize);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'msgSent(const RTDTransportId,const unsigned long)'
	inline void msgSent( const RTDTransportId transport, const unsigned long size )
	{
		// {{{USR operation 'msgSent(const RTDTransportId,const unsigned long)'
		if ( transport < maxTransports )
			transportStats[transport].msgSent(size);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'msgReceived(const RTDTransportId,const unsigned char,const unsigned long,const unsigned long)'
	inline void msgReceived( const RTDTransportId transport, const unsigned char dataFlag, const unsigned long size, const unsigned long dataSize )
	{
		// {{{USR operation 'msgReceived(const RTDTransportId,const unsigned char,const unsigned long,const unsigned long)'
		if ( transport < maxTransports )
			transportStats[transport].msgReceived( dataFlag, size, dataSize);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'msgReceived(const RTDTransportId,const unsigned long)'
	inline void msgReceived( const RTDTransportId transport, const unsigned long size )
	{
		// {{{USR operation 'msgReceived(const RTDTransportId,const unsigned long)'
		if ( transport < maxTransports )
			transportStats[transport].msgReceived( size );
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'resetStats()'
	void resetStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'updateStats(const RTDTransportId,const RTDTransportStats::RTDReasons)'
	inline void updateStats( const RTDTransportId transport, const RTDTransportStats::RTDReasons type )
	{
		// {{{USR operation 'updateStats(const RTDTransportId,const RTDTransportStats::RTDReasons)'
		if ( transport < maxTransports )
			transportStats[transport].updateStats(type);
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'updateStats(RTDStats::RTDReasons)'
	inline void updateStats( RTDStats::RTDReasons type )
	{
		// {{{USR operation 'updateStats(RTDStats::RTDReasons)'
		generalStats[type]++;
		// }}}USR
	}
	// }}}RME
	// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' operation 'updateControllerStats(RTDStats::RTDControllerReasons)'
	inline void updateControllerStats( RTDStats::RTDControllerReasons type )
	{
		// {{{USR operation 'updateControllerStats(RTDStats::RTDControllerReasons)'
		controllerStats[type]++;
		// }}}USR
	}
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSComponents::DCSStats::RTDMetricStats' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDMetricStats_H */

// }}}RME
