// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats'

#ifndef RTDStats_H
#define RTDStats_H

#ifdef PRAGMA
#pragma interface "RTDStats.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDTransportStats.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'


// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDControllerReasons' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDReasons' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

extern const RTObject_class RTType_RTDStats;

class RTDStats
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDControllerReasons'
	enum RTDControllerReasons
	{
		RTDLocalSubscriptions = 0,
		RTDExplicitSubscriptions = 1,
		RTDGlobalSubscriptions = 2,
		RTDRemoteSubscriptions = 3,
		RTDLocalPublications = 4,
		RTDGlobalPublications = 5,
		RTDBindings = 6,
		RTDEmptyPublications = 7,
		RTDFullPublications = 8,
		RTDFreedPublications = 9,
		RTDConnectRetries = 10,
		RTDSubscribeRetries = 11,
		RTDPublishRetries = 12,
		RTDAuditsSent = 13,
		RTDAuditsReceived = 14,
		RTDAuditFailures = 15,
		RTDAuditErrors = 16,
		RTDFailedDCSSubscriptions = 17,
		RTDFailedDCSPublications = 18,
		RTDFailedReplicationSubscriptions = 19,
		RTDFailedReplicationPublications = 20,
		RTDFailedSyntaxSubscriptions = 21,
		RTDFailedSyntaxPublications = 22,
		RTDFailedCircuitSubscriptions = 23,
		RTDFailedTransportSubscriptions = 24,
		RTDFailedRemoteSubscriptions = 25,
		RTDFailedGlobalSubscriptions = 26,
		RTDFailedGlobalPublications = 27,
		RTDFailedGlobalTransportSubscriptions = 28,
		RTDFailedBindings = 29,
		RTDMaxControllerReasons = 30
	};
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDReasons'
	enum RTDReasons
	{
		RTDEncodeExceedsMaxSize = 0,
		RTDEncodeBufferUnavailable = 1,
		RTDTypeVersionMismatch = 2,
		RTDUnknownTypeReceived = 3,
		RTDAllocateFailed = 4,
		RTDDecodingPastEnd = 5,
		RTDUnknownDecoding = 6,
		RTDDecodeFailure = 7,
		RTDEncodeFailure = 8,
		RTDCNXtoqlExceeded = 9,
		RTDCNXtepqlExceeded = 10,
		RTDCNXtiqlExceeded = 11,
		RTDUnavailableTransport = 12,
		RTDVCMismatch = 13,
		RTDLocalRequest = 14,
		RTDConnectsRequested = 15,
		RTDConnectSuccessRejected = 16,
		RTDConnectsMade = 17,
		RTDConnectsRepliedTo = 18,
		RTDConnectFailuresSent = 19,
		RTDConnectFailuresReceived = 20,
		RTDPortsBound = 21,
		RTDPortBindFailure = 22,
		RTDOOSEndpointRequest = 23,
		RTDTransportErrorsSent = 24,
		RTDInternalError = 25,
		RTDUnknownSignal = 26,
		RTDIncompatibleSubtype = 27,
		RTDIncompatibleRequest = 28,
		RTDIncompatibleEncoding = 29,
		RTDUnsupported = 30,
		RTDRegisterFailure = 31,
		RTDMaxReasons = 32
	};
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' classAttribute 'transportStats'
	RTDTransportStats * transportStats;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' classAttribute 'generalStats'
	unsigned long generalStats[RTDStats::RTDMaxReasons];
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' classAttribute 'controllerStats'
	unsigned long controllerStats[RTDStats::RTDMaxControllerReasons];
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' classAttribute 'maxTransports'
	int maxTransports;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' classAttribute 'timeStamp'
	RTTimespec timeStamp;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'RTDStats()'
	RTDStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'RTDStats(const RTDStats &)'
	RTDStats( const RTDStats & copy );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation '~RTDStats()'
	~RTDStats( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'operator=(const RTDStats &)'
	const RTDStats & operator=( const RTDStats & rhs );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getGeneralStatReason(const int)'
	unsigned long getGeneralStatReason( const int reasonIndx ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getControllerStatReason(const int)'
	unsigned long getControllerStatReason( const int reasonIndx ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'setTimeStamp(RTTimespec)'
	void setTimeStamp( RTTimespec currTime );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getTimeStamp()'
	RTTimespec getTimeStamp( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getNumTransports()'
	int getNumTransports( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getTransportName(const int)'
	RTString getTransportName( const int transportIndx = 0 ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getTransportReason(const int,const int)'
	unsigned long getTransportReason( const int transpIndx, const int reasonIndx ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getGeneralStats()'
	const unsigned long * getGeneralStats( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getControllerStats()'
	const unsigned long * getControllerStats( void ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'getTransportStat(int)'
	const RTDTransportStats * getTransportStat( int statIndx ) const;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'setNumTransports(int)'
	void setNumTransports( int numTransps );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'setTransportStatArray(RTDTransportStats *)'
	void setTransportStatArray( RTDTransportStats * stats );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' operation 'setTransportStatArrElem(int,RTDTransportStats &)'
	int setTransportStatArrElem( int elemIndx, RTDTransportStats & elem );
	// }}}RME
	static const RTFieldDescriptor rtg_RTDStats_fields[];
};

struct RTTypedValue_RTDStats
{
	const void * data;
	const RTObject_class * type;
	inline RTTypedValue_RTDStats( const RTDStats & rtg_value )
		: data( &rtg_value ), type( &RTType_RTDStats )
	{
	}
	inline RTTypedValue_RTDStats( const RTDStats & rtg_value, const RTObject_class * rtg_type )
		: data( &rtg_value ), type( rtg_type )
	{
	}
	inline ~RTTypedValue_RTDStats( void )
	{
	}
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDControllerReasons' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME
// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDInterface::RTDStats::RTDReasons' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDStats_H */

// }}}RME
