// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEnums'

#ifndef RTDTraceEnums_H
#define RTDTraceEnums_H

#ifdef PRAGMA
#pragma interface "RTDTraceEnums.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEnums' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// Enumeration of trace groups used for enhanced viewer tracing
#ifdef      BEGIN_TRACE_LIST
#   undef   BEGIN_TRACE_LIST
#   undef   END_TRACE_LIST
#   undef   DEFINE_TRACE_GROUP
#   undef   DEFINE_TRACE_TYPE
#endif

#define BEGIN_TRACE_LIST(listName) \
            enum RTD ## listName { 

#define END_TRACE_LIST(listName)  \
            RTDLast ## listName }

#define DEFINE_TRACE_GROUP(longName,enumName) \
            enumName,
            
#define DEFINE_TRACE_TYPE   DEFINE_TRACE_GROUP

BEGIN_TRACE_LIST(TraceGroup)
	DEFINE_TRACE_GROUP(TargetAgent,RTD_TRG_TA)
	DEFINE_TRACE_GROUP(DCSUserDataIn,RTD_TRG_USERDATA_IN)
	DEFINE_TRACE_GROUP(DCSUserDataOut,RTD_TRG_USERDATA_OUT)
	DEFINE_TRACE_GROUP(DCSNetworkDataIn,RTD_TRG_NETDATA_IN)
	DEFINE_TRACE_GROUP(DCSNetworkDataOut,RTD_TRG_NETDATA_OUT)
	DEFINE_TRACE_GROUP(DCSUserConfig,RTD_TRG_USER_CONFIG)
	DEFINE_TRACE_GROUP(DCSController,RTD_TRG_CONTROLLER)
	DEFINE_TRACE_GROUP(DCSControllerAudit,RTD_TRG_CONTROLLER_AUDIT)
	DEFINE_TRACE_GROUP(DCSLocator,RTD_TRG_LOCATOR)
	DEFINE_TRACE_GROUP(DCSLocatorAudit,RTD_TRG_LOCATOR_AUDIT)
	DEFINE_TRACE_GROUP(DCSTransporter,RTD_TRG_TRANSPORTER)
	DEFINE_TRACE_GROUP(DCSTransporterAudit,RTD_TRG_TRANSPORTER_AUDIT)
	DEFINE_TRACE_GROUP(DCSTransportIntegration,RTD_TRG_TRANSPORT_INTEGRATION)
END_TRACE_LIST(TraceGroup);

//	Edit this list with care.
//
BEGIN_TRACE_LIST(TraceType)
	DEFINE_TRACE_TYPE(RTDStandardTraceType,RTD_TT_STANDARD)
	DEFINE_TRACE_TYPE(RTDProtocolTraceType,RTD_TT_PROTOCOL)
	DEFINE_TRACE_TYPE(RTDStandardTraceTrigger,RTD_TT_TRIGGER)
	DEFINE_TRACE_TYPE(RTDSoftwareDebugTraceType,RTD_TT_SWDEBUG)
	DEFINE_TRACE_TYPE(RTDSoftwareErrorTraceType,RTD_TT_SWERR)
	DEFINE_TRACE_TYPE(RTDSoftwareWarningTraceType,RTD_TT_SWWARN)
END_TRACE_LIST(TraceType);

// }}}USR
// }}}RME

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTraceInterfaces::RTDTraceEnums' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTraceEnums_H */

// }}}RME
