// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport'

#ifndef RTDTransport_H
#define RTDTransport_H

#ifdef PRAGMA
#pragma interface "RTDTransport.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
#include <RTDResult.h>
#include <RTDTransportProfile.h>
class RTDConnexisAPI;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class RTDTransport
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' classAttribute 'cnxAPI'
	const RTDConnexisAPI * cnxAPI;
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDTransport( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDTransport( void );
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	inline RTDTransport & operator=( const RTDTransport & rtg_arg )
	{
		if( this != &rtg_arg )
			cnxAPI = rtg_arg.cnxAPI;
		return *this;
	}
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'startTransport(const RTDConnexisAPI *)'
	virtual RTDResult startTransport( const RTDConnexisAPI * connexisAPI ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'shutdownTransport()'
	virtual RTDResult shutdownTransport( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'configureTransport(RTDTransportProfile &)'
	virtual RTDResult configureTransport( RTDTransportProfile & profile ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'cnxDump()'
	virtual void cnxDump( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'cnxHelp()'
	virtual void cnxHelp( void ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' operation 'log(const char *)'
	void log( const char * text );
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransport' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransport_H */

// }}}RME
