// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory'

#ifndef RTDTransportEndpointFactory_H
#define RTDTransportEndpointFactory_H

#ifdef PRAGMA
#pragma interface "RTDTransportEndpointFactory.h"
#endif

#include <RTSystem/RTDTransportIntegrationFramework.h>
struct RTDConnectionId;
class RTDConnexisAPI;
class RTDTransportAddress;
class RTDTransportEndpoint;

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR tool 'OT::Cpp' property 'HeaderPreface'
// }}}USR
// }}}RME

class RTDTransportEndpointFactory
{
public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PublicDeclarations'
	// }}}USR
	// }}}RME

protected:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR tool 'OT::Cpp' property 'ProtectedDeclarations'
	// }}}USR
	// }}}RME

private:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR tool 'OT::Cpp' property 'PrivateDeclarations'
	// }}}USR
	// }}}RME

public:
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	RTDTransportEndpointFactory( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~RTDTransportEndpointFactory( void );
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' operation 'newTransportEndpoint(const RTDTransportAddress &,const RTDConnectionId &,const RTDConnexisAPI *)'
	virtual RTDTransportEndpoint * newTransportEndpoint( const RTDTransportAddress & address, const RTDConnectionId & cid, const RTDConnexisAPI * connexisAPI ) = 0;
	// }}}RME
	// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' operation 'releaseTransportEndpoint(RTDTransportEndpoint * &)'
	virtual void releaseTransportEndpoint( RTDTransportEndpoint * & endpoint ) = 0;
	// }}}RME
};

// {{{RME classifier 'Logical View::DCSModelInterfaces::RTDTransportIntegrationClasses::RTDTransportIntegration::RTDTransportEndpointFactory' tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR tool 'OT::Cpp' property 'HeaderEnding'
// }}}USR
// }}}RME

#endif /* RTDTransportEndpointFactory_H */

// }}}RME
